package common;
import java.awt.Color;



public class DefaultColorMap implements ColorMap {

	@Override
	public Color colorOf(String id) {
		return colorMap(id);
	}

	// nameOf(skill)
	//   skill: String = a skill name
	// returns category name of skill, or 'Unknown' if not found
	public String nameOf(String skill) {
		//Color lang = Color.orange;
		final Color lang = new Color(255, 144, 0);
		final Color web = Color.red;
		final Color system = Color.blue;
		final Color windows = Color.yellow;
		final Color graphics = Color.green;
		final Color fab = Color.white;
		final Color unknown = Color.black;
		
		Color color = colorOf(skill);
		if (color.equals(lang)) return "Programming Languages";
		if (color.equals(web)) return "Web";
		if (color.equals(system)) return "Systems";
		if (color.equals(windows)) return "Windows";
		if (color.equals(graphics)) return "Graphics";
		if (color.equals(fab)) return "Misc";
		return "Unknown";
	}

	// elem(s, ts)
	//   s : String    = a string
	//   ts: String... = more strings
	// returns true if s is equal to any of the strings in ts, false otherwise
	public static boolean elem(String s, String... ts)
	{
		for (String t : ts) {
			if (s.equals(t)) return true;
		}
		return false;
	}
	
	// colorMap(skill)
	//   skill: String = a skill name
	// returns color associated with given skill, or black if none defined
	public static Color colorMap(String skill) 
	{
		Color lang = Color.orange;
		lang = new Color(255, 144, 0);
		Color web = Color.red;
		Color system = Color.blue;
		Color windows = Color.yellow;
		Color graphics = Color.green;
		Color fab = Color.white;
		Color unknown = Color.black;
		
		if (elem(skill, "XHTML","JavaScript","CSS")) return web;

		if (elem(skill, "Perl", "VB", "C++", "C", "Matlab", "Haskell",
				"CMake")) 
			return lang;

		if (elem(skill, "Linux", "Unix", "Apache", "MySQL", "System Administration", 
				"Tech. Support", "Tech Support", "Unix Scripting","Bash",
				"PC Hardware", "Parallel Programming")) return system;

		if (elem(skill, "Excel", "Access", "InstallShield", "Win32 Scripting", 
				"Win32"))
			return windows;

		if (elem(skill, "Gimp", "Graph Viz", "Visualization", "OpenGL", "R", "Qt")) 
			return graphics;

		if (elem(skill, "Machining", "Soldering", "Wiring", "Electronic Repair"))
			return fab;

		if (skill == "BSCS") return new Color(172, 231, 255);
		if (skill == "MSCS") return new Color(119, 174, 236);
		
		System.out.println("Colormap error: no color value defined for name: '" 
				+ skill + "'");
		return unknown;
	}
}
